<template>
  <div class="ob-mask-container">
    <input
      :id="id"
      ref="input"
      v-mask="config"
      data-attr="ob-mask-container"
      class="input"
      type="text"
      :value="display"
      :disabled="disabled"
      :readonly="readonly"
      :tabindex="disabled || readonly ? -1 : 0"
      :data-qa="dataQa"
      @focus="onFocusNative"
      @input="onInput"
      @blur="onBlurHandler"
      @keydown="onKeyDownHandler"
      @change="onChangeHandler"
    >
    <div
      class="mask"
      v-html="displayMasked"
    />
  </div>
</template>

<script>
import mask from '../directives/mask'
import tokens from '../tokens'
import masker from '../utils/masker'
import UniqueIdMixin from '../../../mixins/unique-id'

export default {
  name: 'ObMask',
  directives: {
    mask
  },
  mixins: [
    UniqueIdMixin
  ],
  props: {
    value: [String, Number],
    mask: {
      type: [String, Array],
      required: true
    },
    isMasked: {
      type: Boolean,
      default: false
    },
    tokens: {
      type: Object,
      default: () => tokens
    },
    disabled: {
      type: Boolean,
      default: false
    },
    readonly: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      lastValue: null,
      display: this.value
    }
  },
  computed: {
    config () {
      return {
        mask: this.mask,
        tokens: this.tokens,
        masked: this.isMasked
      }
    },
    maskedValue () {
      return masker(this.display, this.mask, true, this.tokens)
    },
    displayMasked () {
      let value = this.display

      if (value) {
        return `<span style="color: transparent!important;">${this.maskedValue}</span>${this.mask.substr(this.maskedValue.length, this.mask.length)}`
      } else {
        return this.mask
      }
    }
  },
  watch: {
    value (newValue) {
      if (this.lastValue !== newValue) {
        this.display = newValue
      }
    },
    masked () {
      this.refresh(this.display)
    }
  },
  methods: {
    onInput (e) {
      if (e.isTrusted) return
      this.refresh(e.target.value)
    },
    refresh (value) {
      this.display = value
      value = masker(value, this.mask, this.isMasked, this.tokens)
      if (value !== this.lastValue) {
        this.lastValue = value
        this.$emit('input', value)
      }
    },
    focus () {
      this.$refs.input && this.$refs.input.focus()
    },
    onFocusNative () {
      this.$emit('on-focus')
    },
    onBlurHandler (event) {
      if (event) {
        this.$emit('on-blur', event)
      }
    },
    onKeyDownHandler (e) {
      let keyCode = e.keyCode
      if (keyCode === 13) {
        this.$emit('on-enter', e)
      }
    },
    onChangeHandler (e) {
      this.$emit('on-change', e)
    },
    isValidMask () {
      return this.maskedValue.length === this.mask.length
    }
  }
}
</script>

<style lang="scss" scoped>
  .container {
    position: relative;
    min-height: 20px;
  }
  .input, .mask {
    width: 100%;
    background-color: transparent;
    border: none!important;
    font-family: Roboto, sans-serif;
    font-style: normal;
    font-weight: normal;
    font-size: 16px;
    line-height: 20px;
    letter-spacing: 0.2px;
    text-align: left;
    &[disabled] {
      color: $color-grey-span;
    }
  }

  .input {
    position: relative;
    z-index: 10;
    outline: none;
    border: 1px solid grey;
    &:focus {
      border: 1px solid blue;
    }
  }

  .mask {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    border: 1px solid transparent;
    color: $gray-window;
  }
</style>
